// DlgRemoteVideo.cpp : implementation file
//

#include "stdafx.h"
#include "DlgScreenVideo.h"
#include "afxdialogex.h"


// CDlgScreenVideo dialog

IMPLEMENT_DYNAMIC(CDlgScreenVideo, CDialogEx)

CDlgScreenVideo::CDlgScreenVideo(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDlgScreenVideo::IDD, pParent)
	, m_isVideoShowed(true)
{
	m_sessionID = -1;
	m_SipLib = NULL;
}

CDlgScreenVideo::~CDlgScreenVideo()
{
}

void CDlgScreenVideo::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	
}


BEGIN_MESSAGE_MAP(CDlgScreenVideo, CDialogEx)
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_WM_DESTROY()
//	ON_WM_WINDOWPOSCHANGED()
END_MESSAGE_MAP()


// CDlgScreenVideo message handlers
void CDlgScreenVideo::setRemoteVideo(void * sipLib, long sessionID, void * oldRemoteVideoWindow)
{
	m_SipLib = sipLib;
	m_sessionID = sessionID;
	PortSIP_setRemoteScreenWindow(m_SipLib, m_sessionID,m_hWnd);
	//PortSIP_setRemoteVideoWindow(m_SipLib, m_sessionID, m_remoteVideo.m_hWnd);
	m_isVideoShowed = true;
	m_oldRemoteVideoWindow = oldRemoteVideoWindow;
	showVideoWindows(TRUE);
}

void CDlgScreenVideo::OnSize(UINT nType, int cx, int cy)
{
	CDialogEx::OnSize(nType, cx, cy);

	if (m_SipLib != NULL && m_sessionID > 0)
	{
		// TODO: Add your message handler code here
		PortSIP_setRemoteScreenWindow(m_SipLib, m_sessionID, NULL);
		PortSIP_setRemoteScreenWindow(m_SipLib, m_sessionID, this->m_hWnd);
	}
}

void CDlgScreenVideo::showVideoWindows(BOOL max)
{
	if (!max)
	{
		//LONG lStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
		//::SetWindowLong(m_hWnd, GWL_STYLE, lStyle | WS_CAPTION);
		//::SetWindowPos(m_hWnd, NULL, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE | SWP_FRAMECHANGED);
		//::ShowWindow(::FindWindow(_T("Shell_TrayWnd"), NULL), SW_SHOW);
		ShowWindow(SW_HIDE);
		hideVideoWindows();
	}
	else
	{
		LONG lStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
		::SetWindowLong(m_hWnd, GWL_STYLE, lStyle&~WS_CAPTION);
		::ShowWindow(::FindWindow(_T("Shell_TrayWnd"), NULL), SW_HIDE);
		::SetWindowPos(m_hWnd, NULL, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE | SWP_FRAMECHANGED);
		ShowWindow(SW_MAXIMIZE);
	};
}

void CDlgScreenVideo::hideVideoWindows()
{

	::ShowWindow(::FindWindow(_T("Shell_TrayWnd"), NULL), SW_SHOW);

	if (m_isVideoShowed)
	{
		//set back
		PortSIP_setRemoteScreenWindow(m_SipLib, m_sessionID, NULL);
		//PortSIP_setRemoteVideoWindow(m_SipLib, m_sessionID, m_oldRemoteVideoWindow);
		m_isVideoShowed = false;
	}
}

void CDlgScreenVideo::OnStnDblclickDispremotevideo()
{
	if (IsZoomed())
	{
		showVideoWindows(FALSE);
	}
	else
	{
		showVideoWindows(TRUE);
	}
}


void CDlgScreenVideo::OnClose()
{
	hideVideoWindows();
	CDialogEx::OnClose();
}


void CDlgScreenVideo::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: Add your message handler code here
	hideVideoWindows();
}


void CDlgScreenVideo::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class
	hideVideoWindows();
	CDialogEx::OnCancel();
}
